Subject: Re: bug#23966: 25.1.50; Frame resizing due to tool bar + Gnus

From: Stephen Berman <[email-masked]>
Date: Mon, 20 Jul 2020 11:10:48 +0200

On Sun, 19 Jul 2020 18:02:15 +0200 Lars Ingebrigtsen <[email-masked]> wrote:

> OK, I'm trying to reproduce this in Emacs 28, and...  I'm getting all
> kinds of strangeness.
>
> I usually don't use tool bars, but if I just enter a summary mode buffer
> and say M-x tool-bar-mode, then I don't actually get a tool bar -- I
> just get a ~10-pixel high grey stripe at the top.
>
> This may be because gnus-summary-tool-bar is
> 'gnus-summary-tool-bar-retro?
>
> If, on the other hand, I switch tool-bar-mode on before starting Gnus,
> then I do get a tool bar, and that variable is
> 'gnus-summary-tool-bar-gnome.
>
> This is because
>
> (defcustom gnus-summary-tool-bar (if (eq gmm-tool-bar-style 'gnome)
> 				     'gnus-summary-tool-bar-gnome
> 				   'gnus-summary-tool-bar-retro)
>
> and
>
> (defcustom gmm-tool-bar-style
>   (if (and (boundp 'tool-bar-mode)
> 	   tool-bar-mode
> 	   (not (memq (display-visual-class)
> 		      (list 'static-gray 'gray-scale
> 		            'static-color 'pseudo-color))))
>       'gnome
>     'retro)
>   "Preferred tool bar style."
>   :type '(choice (const :tag "GNOME style" gnome)
> 		 (const :tag "Retro look"  retro))
>   :group 'gmm)
>
> so that's set at load time, and depends on whether you've switched tool
> bar mode on or not before loading the file.  Which seems less than
> optimal...
>
> Anyway, is this a different bug than what you were all talking about?
> :-)

It seems like the same bug, or at least related.  In any case, when I
run the test code Martin posted in <[email-masked]> on a
currentish (2020-07-01) build from master, I get similar but not
identical results to those I got two years ago:

Emacs started; frame pixel height: 612  toolbar height: 41
Gnus started; frame pixel height: 612  toolbar height: 41
Opening nnfolder server on archive...done
Subscribe newsgroup: nnfolder+archive:sent
Subscribe newsgroup: nnfolder+archive:##
Subscribe newsgroup: nnfolder+archive:emacs-personal
3 new newsgroups have arrived
Checking new news...
Reading active file via nnnil...done
Reading active file from archive via nnfolder...done
Checking new news...done
Opening nndoc server on /home/steve/tool-bar-Gnus-frame-bug...done
Tool bar disabled; frame pixel height: 612  toolbar height: 0
Entered Summary buffer; frame pixel height: 612  toolbar height: 0
Tool bar enabled; frame pixel height: 646  toolbar height: 7
Other buffer; frame pixel height: 646  toolbar height: 41
Back to Summary buffer; frame pixel height: 680  toolbar height: 7
Final; frame pixel height: 680  toolbar height: 41

Moreover, I get these exact same results regardless of whether
frame-resize-pixelwise it nil or t, which is different from two years
ago, and also when I set gmm-tool-bar-style to 'gnome or
gnus-summary-tool-bar to 'gnus-summary-tool-bar-gnome before evaluating
the test code.

Steve Berman